CREATE TABLE tasks (
    id integer GENERATED BY DEFAULT AS IDENTITY PRIMARY KEY,
    owner integer NOT NULL REFERENCES users(id),
    name text NOT NULL,
    notes text,
    schedule jsonb NOT NULL DEFAULT '{}',
    created_at timestamptz NOT NULL DEFAULT CURRENT_TIMESTAMP,
    updated_at timestamptz NOT NULL DEFAULT CURRENT_TIMESTAMP
);

CREATE TRIGGER set_tasks_updated BEFORE UPDATE ON tasks FOR EACH ROW EXECUTE PROCEDURE set_updated_timestamp();
